/* $Id: connection.h 396 2010-04-17 12:58:10Z oh2gve $
 *
 * Copyright 2010, 2011 Tapio Aaltonen
 *
 * 
 * This file is part of aprsg.
 *
 * aprsg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * aprsg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with aprsg.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 * APRS is a registered trademark of APRS Software and Bob Bruninga, WB4APR.
*/


#ifndef CONTROLLER_H
#define CONTROLLER_H


// own stuff.
#include "../cfg.h"
#include "../connection.h"
#include "../uplink.h"
#include "../packetlog.h"

// std stuff.
#include <vector>

// wx stuff.
#include <wx/thread.h>
#include <wx/string.h>
#include <wx/frame.h>


/// Main thread, controls all self-created threads.
class Controller : public wxThread
{
public:
	
	Controller(wxFrame* parent, Cfg::Configuration const& cfg,
	           Uplink* uplink, std::vector<Connection*>& cons,
	           Packetlog* packetlog);
	virtual ~Controller();

	/// Entry point of our thread. The actual "main" function for this  thread.
	virtual ExitCode Entry();

	/// Event id's for events sent by this thread.
	enum EventID { ID_fatalError, ID_newPacket };

private:

	// Posts an event to main thread.
	void eventToMain(EventID id, wxString const& text = wxT(""));

	// Main window receives the events we send.
	wxFrame* parent_;


	Cfg::Configuration const& configuration_;
	Uplink* uplink_;
	std::vector<Connection*>& connections_;
	Packetlog* packetlog_;
};

#endif // CONTROLLER_H
