/* $Id: main.h 400 2010-04-17 18:16:56Z oh2gve $
 *
 * Copyright 2010, 2011 Tapio Aaltonen
 *
 *
 * This file is part of aprsg.
 *
 * aprsg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * aprsg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with aprsg.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * APRS is a registered trademark of APRS Software and Bob Bruninga, WB4APR.
*/

#ifndef WINDOW_H
#define WINDOW_H

#include "icon.h"
#include "controller.h"

#include <wx/frame.h>
#include <wx/string.h>


class Window : public wxFrame
{
public:

	Window(wxString const& title);
	virtual ~Window();

private:

	// Taskbar icon of the app.
	Icon* icon_;


	// Id:s for events from this window.
	enum EventIds { ID_FileQuit, ID_HelpAbout };

	// Event handlers for own events.
	void onFileQuit(wxCommandEvent& event);
	void onHelpAbout(wxCommandEvent& event);
	void onClose(wxCloseEvent& event);


	// Event handlers for controller thread events.
	void onControllerFailure(wxCommandEvent& event);
	void onControllerNewPacket(wxCommandEvent& event);

	DECLARE_EVENT_TABLE()

};
#endif // WINDOW_H
